base-4.10.1.0: Basic libraries

Copyright | (c) Ashley Yakeley 2007
License | BSD-style (see the LICENSE file in the distribution)
Maintainer | ashley@semantic.org
Stability | experimental
Portability | portable
Safe Haskell | Trustworthy
Language | Haskell2010

Control.Category

Description

Synopsis

- class Category cat where
- (<<<) :: Category cat => cat b c -> cat a b -> cat a c
- (>>>) :: Category cat => cat a b -> cat b c -> cat a c

# Documentation

class Category cat where #

A class for categories. id and (.) must form a monoid.

Minimal complete definition

id, (.)

Methods

id :: cat a a #

the identity morphism

(.) :: cat b c -> cat a b -> cat a c infixr 9 #

morphism composition

Instances

Category k (Coercion k) # | Since: 4.7.0.0
Methods id :: cat a a # (.) :: cat b c -> cat a b -> cat a c #
Category k ((:~:) k) # | Since: 4.7.0.0
Methods id :: cat a a # (.) :: cat b c -> cat a b -> cat a c #
Category k ((:~~:) k k) # | Since: 4.10.0.0
Methods id :: cat a a # (.) :: cat b c -> cat a b -> cat a c #
Monad m => Category * (Kleisli m) # | Since: 3.0
Methods id :: cat a a # (.) :: cat b c -> cat a b -> cat a c #
Category * ((->) LiftedRep LiftedRep) # | Since: 3.0
Methods id :: cat a a # (.) :: cat b c -> cat a b -> cat a c #

(<<<) :: Category cat => cat b c -> cat a b -> cat a c infixr 1 #

Right-to-left composition

(>>>) :: Category cat => cat a b -> cat b c -> cat a c infixr 1 #

Left-to-right composition